
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>3socket编程：UDP编程 / 憋错料</title>

    <meta name="description" content="3socket编程：UDP编程 ﻿﻿ 1 C/S模型-UDP UDP处理模型 说明: 由于UDP不需要维护连接,程序逻辑简单了很多,但是UDP协议是不可靠的,实际上有很多保证通讯可靠性的机制需要在应用层实现. 编译运行server,在两个终端里各开一个client与server交互,看看server是否具有并 发服务的能力.用Ctrl+C关闭server,然后再运行server,看此时client还能否和server联 系上.和前面TCP程序的运行结果相比较,体会无连接的含义. 2 案例说明: Server.c #includ">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">3socket编程：UDP编程</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>&#65279;&#65279;</p>
<p>1 C/S模型—UDP</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA5MzAyMjIwNDcwMDM/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZEc5MGIzUjFlblZ2Y1hWaGJnPT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9Tb3V0aEVhc3Q=.jpg"></p>
<p>UDP处理模型</p>
<p>说明：</p>
<p>由于UDP不需要维护连接，程序逻辑简单了很多，但是UDP协议是不可靠的，实际上有很多保证通讯可靠性的机制需要在应用层实现。</p>
<p>编译运行server，在两个终端里各开一个client与server交互，看看server是否具有并</p>
<p>发服务的能力。用Ctrl&#043;C关闭server，然后再运行server，看此时client还能否和server联</p>
<p>系上。和前面TCP程序的运行结果相比较，体会无连接的含义。</p>
<p>2<br />
案例说明：</p>
<p>Server.c</p>
<table>
<tbody>
<tr>
<td>
<br />#include&lt;stdio.h&gt;</p>
<p>#include&lt;stdlib.h&gt;</p>
<p>#include&lt;string.h&gt;</p>
<p>#include&lt;netinet/in.h&gt;</p>
<p>#include&lt;arpa/inet.h&gt;</p>
<p>#include&lt;ctype.h&gt;</p>
<p>#include&quot;wrap.h&quot;</p>
<p>#define MAXLINE 80</p>
<p>#define SERV_PORT 8000</p>
<p>int main(void)</p>
<p>{</p>
<p>struct sockaddr_in servaddr,cliaddr;</p>
<p>socklen_t cliaddr_len;</p>
<p>int sockfd;</p>
<p>char buf[MAXLINE];</p>
<p>char str[INET_ADDRSTRLEN];</p>
<p>int i,n;</p>
<p>sockfd = Socket(AF_INET,SOCK_DGRAM,0);</p>
<p>bzero(&amp;servaddr,sizeof(servaddr));</p>
<p>servaddr.sin_family = AF_INET;</p>
<p>servaddr.sin_addr.s_addr = htonl(INADDR_ANY);</p>
<p>servaddr.sin_port = htons(SERV_PORT);</p>
<p>Bind(sockfd,(struct sockaddr *)&amp;servaddr,sizeof(servaddr));</p>
<p>printf(&quot;Accepting connections...\n&quot;);</p>
<p>while(1) {</p>
<p>cliaddr_len = sizeof(cliaddr);</p>
<p>n = recvfrom(sockfd,buf,MAXLINE,0,</p>
<p>(struct sockaddr *)&amp;cliaddr,&amp;cliaddr_len);</p>
<p>if(n == -1)</p>
<p>perr_exit(&quot;recvfrom error&quot;);</p>
<p>printf(&quot;received from %s at PORT %d\n&quot;,</p>
<p>inet_ntop(AF_INET,&amp;cliaddr.sin_addr,str,sizeof(str)),</p>
<p>ntohs(cliaddr.sin_port));</p>
<p>for(i = 0;i&lt;n;i&#043;&#043;){</p>
<p>buf[i] = toupper(buf[i]);</p>
<p>}</p>
<p>n = sendto(sockfd,buf,n,0,(struct sockaddr *)&amp;cliaddr,sizeof(cliaddr));</p>
<p>if(n== -1)</p>
<p>perr_exit(&quot;sendto error&quot;);</p>
<p>}</p>
<p>}</p>
</td>
</tr>
</tbody>
</table>
<p>Client.c</p>
<table>
<tbody>
<tr>
<td>
<br />#include&lt;stdio.h&gt;</p>
<p>#include&lt;string.h&gt;</p>
<p>#include&lt;unistd.h&gt;</p>
<p>#include&lt;netinet/in.h&gt;</p>
<p>#include&lt;arpa/inet.h&gt;</p>
<p>#include&quot;wrap.h&quot;</p>
<p>#define MAXLINE 80</p>
<p>#define SERV_PORT 8000</p>
<p>int main(int argc,char *argv[])</p>
<p>{</p>
<p>struct sockaddr_in servaddr;</p>
<p>int sockfd,n;</p>
<p>char buf[MAXLINE];</p>
<p>char str[INET_ADDRSTRLEN];</p>
<p>socklen_t servaddr_len;</p>
<p>sockfd = Socket(AF_INET,SOCK_DGRAM,0);</p>
<p>bzero(&amp;servaddr,sizeof(servaddr));</p>
<p>servaddr.sin_family = AF_INET;</p>
<p>inet_pton(AF_INET,&quot;127.0.0.1&quot;,&amp;servaddr.sin_addr);</p>
<p>servaddr.sin_port = htons(SERV_PORT);</p>
<p>while(fgets(buf,MAXLINE,stdin) != NULL) {</p>
<p>n = sendto(sockfd,buf,strlen(buf),0,(struct sockaddr *)&amp;servaddr,</p>
<p>sizeof(servaddr));</p>
<p>if(n == -1)</p>
<p>perr_exit(&quot;sendto error&quot;);</p>
<p>n = recvfrom(sockfd,buf,MAXLINE,0,NULL,0);</p>
<p>if(n == -1)</p>
<p>perr_exit(&quot;recvfrom error&quot;);</p>
<p>Write(STDOUT_FILENO,buf,n);</p>
<p>}</p>
<p>Close(sockfd);</p>
<p>return 0;</p>
<p>}</p>
</td>
</tr>
</tbody>
</table>
<p>Wrap.h</p>
<table>
<tbody>
<tr>
<td>
<br />#ifndef __WRAP_H_</p>
<p>#define __WRAP_H_</p>
<p>void perr_exit(const char *s);</p>
<p>int Accept(int fd, struct sockaddr *sa, socklen_t *salenptr);</p>
<p>void Bind(int fd, const struct sockaddr *sa, socklen_t salen);</p>
<p>void Connect(int fd, const struct sockaddr *sa, socklen_t salen);</p>
<p>void Listen(int fd, int backlog);</p>
<p>int Socket(int family, int type, int protocol);</p>
<p>ssize_t Read(int fd, void *ptr, size_t nbytes);</p>
<p>ssize_t Write(int fd, const void *ptr, size_t nbytes);</p>
<p>void Close(int fd);</p>
<p>ssize_t Readn(int fd, void *vptr, size_t n);</p>
<p>ssize_t Writen(int fd, const void *vptr, size_t n);</p>
<p>static ssize_t my_read(int fd, char *ptr);</p>
<p>ssize_t Readline(int fd, void *vptr, size_t maxlen);</p>
<p>#endif</p>
</td>
</tr>
</tbody>
</table>
<p>Wrap.c</p>
<table>
<tbody>
<tr>
<td>
<br />#include &lt;stdlib.h&gt;</p>
<p>#include &lt;errno.h&gt;</p>
<p>#include &lt;sys/socket.h&gt;</p>
<p>void perr_exit(const char *s)</p>
<p>{</p>
<p>perror(s);</p>
<p>exit(1);</p>
<p>}</p>
<p>int Accept(int fd, struct sockaddr *sa, socklen_t *salenptr)</p>
<p>{</p>
<p>int n;</p>
<p>again:</p>
<p>if ( (n = accept(fd, sa, salenptr)) &lt; 0) {</p>
<p>if ((errno == ECONNABORTED) || (errno == EINTR))</p>
<p>goto again;</p>
<p>else</p>
<p>perr_exit(&quot;accept error&quot;);</p>
<p>}</p>
<p>return n;</p>
<p>}</p>
<p>void Bind(int fd, const struct sockaddr *sa, socklen_t salen)</p>
<p>{</p>
<p>if (bind(fd, sa, salen) &lt; 0)</p>
<p>perr_exit(&quot;bind error&quot;);</p>
<p>}</p>
<p>void Connect(int fd, const struct sockaddr *sa, socklen_t salen)</p>
<p>{</p>
<p>if (connect(fd, sa, salen) &lt; 0)</p>
<p>perr_exit(&quot;connect error&quot;);</p>
<p>}</p>
<p>void Listen(int fd, int backlog)</p>
<p>{</p>
<p>if (listen(fd, backlog) &lt; 0)</p>
<p>perr_exit(&quot;listen error&quot;);</p>
<p>}</p>
<p>int Socket(int family, int type, int protocol)</p>
<p>{</p>
<p>int n;</p>
<p>if ( (n = socket(family, type, protocol)) &lt; 0)</p>
<p>perr_exit(&quot;socket error&quot;);</p>
<p>return n;</p>
<p>}</p>
<p>ssize_t Read(int fd, void *ptr, size_t nbytes)</p>
<p>{</p>
<p>ssize_t n;</p>
<p>again:</p>
<p>if ( (n = read(fd, ptr, nbytes)) == -1) {</p>
<p>if (errno == EINTR)</p>
<p>goto again;</p>
<p>else</p>
<p>return -1;</p>
<p>}</p>
<p>return n;</p>
<p>}</p>
<p>ssize_t Write(int fd, const void *ptr, size_t nbytes)</p>
<p>{</p>
<p>ssize_t n;</p>
<p>again:</p>
<p>if ( (n = write(fd, ptr, nbytes)) == -1) {</p>
<p>if (errno == EINTR)</p>
<p>goto again;</p>
<p>else</p>
<p>return -1;</p>
<p>}</p>
<p>return n;</p>
<p>}</p>
<p>void Close(int fd)</p>
<p>{</p>
<p>if (close(fd) == -1)</p>
<p>perr_exit(&quot;close error&quot;);</p>
<p>}</p>
<p>ssize_t Readn(int fd, void *vptr, size_t n)</p>
<p>{</p>
<p>size_t&nbsp; nleft;</p>
<p>ssize_t nread;</p>
<p>char&nbsp;&nbsp; *ptr;</p>
<p>ptr = vptr;</p>
<p>nleft = n;</p>
<p>while (nleft &gt; 0) {</p>
<p>if ( (nread = read(fd, ptr, nleft)) &lt; 0) {</p>
<p>if (errno == EINTR)</p>
<p>nread = 0;</p>
<p>else</p>
<p>return -1;</p>
<p>} else if (nread == 0)</p>
<p>break;</p>
<p>nleft -= nread;</p>
<p>ptr &#043;= nread;</p>
<p>}</p>
<p>return n - nleft;</p>
<p>}</p>
<p>ssize_t Writen(int fd, const void *vptr, size_t n)</p>
<p>{</p>
<p>size_t nleft;</p>
<p>ssize_t nwritten;</p>
<p>const char *ptr;</p>
<p>ptr = vptr;</p>
<p>nleft = n;</p>
<p>while (nleft &gt; 0) {</p>
<p>if ( (nwritten = write(fd, ptr, nleft)) &lt;= 0) {</p>
<p>if (nwritten &lt; 0 &amp;&amp; errno == EINTR)</p>
<p>nwritten = 0;</p>
<p>else</p>
<p>return -1;</p>
<p>}</p>
<p>nleft -= nwritten;</p>
<p>ptr &#043;= nwritten;</p>
<p>}</p>
<p>return n;</p>
<p>}</p>
<p>static ssize_t my_read(int fd, char *ptr)</p>
<p>{</p>
<p>static int read_cnt;</p>
<p>static char *read_ptr;</p>
<p>static char read_buf[100];</p>
<p>if (read_cnt &lt;= 0) {</p>
<p>again:</p>
<p>if ( (read_cnt = read(fd, read_buf, sizeof(read_buf))) &lt; 0) {</p>
<p>if (errno == EINTR)</p>
<p>goto again;</p>
<p>return -1;</p>
<p>} else if (read_cnt == 0)</p>
<p>return 0;</p>
<p>read_ptr = read_buf;</p>
<p>}</p>
<p>read_cnt--;</p>
<p>*ptr = *read_ptr&#043;&#043;;</p>
<p>return 1;</p>
<p>}</p>
<p>ssize_t Readline(int fd, void *vptr, size_t maxlen)</p>
<p>{</p>
<p>ssize_t n, rc;</p>
<p>char&nbsp;&nbsp;&nbsp; c, *ptr;</p>
<p>ptr = vptr;</p>
<p>for (n = 1; n &lt; maxlen; n&#043;&#043;) {</p>
<p>if ( (rc = my_read(fd, &amp;c)) == 1) {</p>
<p>*ptr&#043;&#043; = c;</p>
<p>if (c&nbsp; == ‘\n‘)</p>
<p>break;</p>
<p>} else if (rc == 0) {</p>
<p>*ptr = 0;</p>
<p>return n - 1;</p>
<p>} else</p>
<p>return -1;</p>
<p>}</p>
<p>*ptr&nbsp; = 0;</p>
<p>return n;</p>
<p>}</p>
</td>
</tr>
</tbody>
</table>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-15 08:33:01 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/color/" title="color">color</a>, <a href="https://www.biecuoliao.com/tag/style/" title="style">style</a>, <a href="https://www.biecuoliao.com/tag/http/" title="http">http</a>, <a href="https://www.biecuoliao.com/tag/for/" title="for">for</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>3socket编程：UDP编程的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPwLdD4.html" rel="bookmark">Linux 网络编程&mdash;&mdash;UDP编程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 UDP 是 User Datagram Protocol 的简称, 中文名是用户数据报协议,是一个简单的面向数据报的运输层协议,在网络中用于处理数据包,是一种无连接的协议.UDP 不提供可靠性的传输,它只是把应用程序传给 IP 层的数据报发送出去,但是并不能保证它们能到达目的地.由于 UDP 在传输数据报前不用在客户和服务器之间建立一个连接,且没有超时重发等机制,故而传输速度很快. UDP 有如下的特点: 1)邮件系统服务模式的抽象(可通过邮件模型来进行对比) 2)每个分组都携带完整的目的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3O181ZM.html" rel="bookmark">37 - 网络编程-UDP编程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				目录 1 UDP协议 2 UDP通信流程 3 UDP编程 3.1 构建服务端 3.3 常用方法 4 聊天室 5 UDP协议应用 1 UDP协议 UDP是面向无连接的协议,使用UDP协议时,不需要建立连接,只需要知道对方的IP地址和端口号,就可以直接发数据包.但是,能不能到达就不知道了.虽然用UDP传输数据不可靠,但它的优点是和TCP比,速度快,对于不要求可靠到达的数据,就可以使用UDP协议. 2 UDP通信流程 我们先来了解一下,python的socket的通讯流程: 服务端: 创建Socket			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVglAj0.html" rel="bookmark">udp编程的学习</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近在做一个网络应用小程序(虽然很烦应用层编程...),实现视频数据通过网络无限发送,不关有无网络,数据都发出,用于产品的老化测试. 起初代码是用TCP写的,TCP有连接,产品作为server,起一个监控connect线程,有client连接,监控线程告诉主线程,主线程就将数据发出,没有client连接,主线程则将数据抛空. 但是有这样一个需求,用户插入网线后,PC端的client接收数据,然后强制拔掉网线,这时server还要一直在发送数据(数据是发出还是抛空无所谓),这样实现产品的长时间运行			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rEZJw0.html" rel="bookmark">Socket编程实践&lpar;12&rpar; --UDP编程基础</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				UDP特点 无连接,面向数据报(基于消息,不会粘包)的数据传输服务; 不可靠(可能会丢包, 乱序, 重复), 但因此一般情况下UDP更加高效; UDP客户/服务器模型 UDP-API使用 #include &lt;sys/types.h&gt; #include &lt;sys/socket.h&gt; ssize_t recvfrom(int sockfd, void *buf, size_t len, int flags, struct sockaddr *src_addr, socklen_t *a			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4ARDpbM.html" rel="bookmark">Linux下的socket编程实践（十） 基本UDP编程细节</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在我的这两篇博客中,简单介绍并实现了基于UDP(TCP)的windows(UNIX下流程基本一致)下的服务端和客户端的程序,本文继续探讨关于UDP编程的一些细节. http://blog.csdn.net/nk_test/article/details/47733307 http://blog.csdn.net/nk_test/article/details/47756381 下图是一个简单的UDP客户/服务器模型: 我在这里也实现了一个简单的UDP回射服务器/客户端: /**实践: 实现一个基			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoxAwQ0.html" rel="bookmark">嵌入式 Linux网络编程（三）&mdash;&mdash;UDP编程模型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				嵌入式 Linux网络编程(三)--UDP编程模型 UDP编程模型: UDP循环服务器模型为: socket(...); bind(...); while(1) {    recvfrom(...);    process(...);    sendto(...); } server.c代码: #include &lt;stdio.h&gt; #include &lt;stdlib.h&gt; #include &lt;string.h&gt; #include &lt;unistd.h&gt; #inc			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kpDz73.html" rel="bookmark">java 网络编程  UDP TCP</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				网络编程 网络编程主要用于解决计算机与计算机(手机.平板..)之间的数据传输问题. 网络编程: 不需要基于html页面就可以达到数据之间的传输. 比如: feiQ , QQ , 微信....网页编程: 就是要基于html页面的基础上进行数据的交互的. 比如: 珍爱网. oa(办公自动化). 高考的报告系统... 计算机网络: 分布在不同地域 的计算机通过外部设备链接起来达到了消息互通.资源共享的效果就称作为一个计算机网络.网络通讯的三要素:    1. IP    2. 端口号.    3. 协			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Moaqjy3.html" rel="bookmark">Linux学习四：UDP编程&lpar;上&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				关于UDP和TCP对比优缺,这里就不说了. 使用UDP代码所掉用的函数和用于TCP的函数非常类似,这主要因为套接口库在底层的TCP和UDP的函数上加了一层抽象,通过这层抽象使得编程更容易,但失去了一些控制. 二者函数调用唯一的实际区别是soceket函数调用的一个参数,TCP的是SOCK_STREAM,UDP的是SOCK_DGRAM,二者都可以使用recvfrom函数,而recv只用于TCP. 当然函数的变化不是这么简单,因为你要从一种有连接的协议转向到无连接的协议上去.这里写个很简单直接的UD			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qEJoG3.html" rel="bookmark">基于Linux下的UDP编程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一. Linux下UDP编程框架 使用UDP进行程序设计可以分为客户端和服务器端两部分. 1.服务器端程序包括: Ø  建立套接字 Ø  将套接字地址结构进行绑定 Ø  读写数据 Ø  关闭套接字 2.客户端程序包括: Ø  建立套接字 Ø  读写数据 Ø  关闭套接字 3.服务器端和客户端程序之间的差别 服务器端和客户端两个流程之间的主要差别在于对地址的绑定函数(bind()函数),而客户端可以不用进行地址和端口的绑定操作. 二.Linux中UDP套接字函数  从图可知,UDP协议的服务端程序			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38pegg3.html" rel="bookmark">Node&period;js开发入门&mdash;UDP编程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Node.js也提供了UDP编程的能力,相关类库在&quot;dgram&quot;模块里. 与TCP不同,UDP是无连接的,不保障数据的可靠性,不过它的编程更为简单,有时候我们也需要它.比如做APP的统计或者日志或者流媒体,很多流媒体协议都会用到UDP,网上一搜一大堆. 使用UDP,如果你要发送数据,只需要知道对方的主机名(地址)和端口号,扔一消息过去即可.至于对方收不收得到,听天由命了.这就是数据报服务,类似快递或邮件. 我们这次来介绍一下Node.js里的UDP编程,我会提供一个UDP版本的echo			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/bMoxAn0.html" rel="bookmark" class="title">Xamarin入门浅析</a>
					<div>
						1. 安装 1) 使用标准安装流程(JDK1.6 -&gt; Android SDK -&gt; NDK -&gt; Xamarin Studio -&gt; Xamarin Visual Studi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/949vpbM.html" rel="bookmark" class="title">fzuoj1607Greedy division</a>
					<div>
						题目链接: 点我点我 题目:  Problem 1607 Greedy division Accept: 436    Submit: 1590 Time Limit: 1000 mSec    Me ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/k0eOVa4.html" rel="bookmark" class="title">vim编辑器的常见使用功能</a>
					<div>
						Vim是一个类似于vi的著名的功能强大.高度可定制的文本编辑器,在Vi的基础上改进和增加了很多特性. 掌握简单的vim命令可以大大提高我们编辑文档效率,在装有vim编辑器的linux系统终端输入vim ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/bMoDob0.html" rel="bookmark" class="title">很多孩子问父母</a>
					<div>
						很多孩子问父母为什么天天让我学习,让我考大学呢?很多父母不知怎么回答,只是泛泛地告诉孩子上大学能学很多东西.原本就被学习压得喘不过气来的孩子听到这样的回答,能有考大学的动力吗?父母是不是应该补补课,了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OmGK7M.html" rel="bookmark" class="title">&lbrack;GodLove&rsqb;Wine93 Tarining Round &num;4</a>
					<div>
						比赛链接: http://acm.hust.edu.cn/vjudge/contest/view.action?cid=44903#overview 题目来源: 2011 Asia ChengDu R ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZVPgl3.html" rel="bookmark" class="title">微信开发配置JSSDK，注入权限验证，以及invalid signature签名错误解决</a>
					<div>
						在微信开发中很多功能都要用到微信JSSDK,关于JSSDK的使用,微信官方的文档已经比较详细,一定要仔细去看文档. &lt;script src=&quot;https://res.wx.qq.com ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPNjrD3.html" rel="bookmark" class="title">AVL树（平衡二叉查找树）</a>
					<div>
						首先要说AVL树,我们就必须先说二叉查找树,先介绍二叉查找树的一些特性,然后我们再来说平衡树的一些特性,结合这些特性,然后来介绍AVL树. 一.二叉查找树 1.二叉树查找树的相关特征定义 二叉树查找树 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDdEp8M.html" rel="bookmark" class="title">【操作系统】之进程管理</a>
					<div>
						定义 进程的典型定义:进程是程序的一次动态执行 进程在传统OS中的定义: 进程是进程实体的运行过程,是系统进行资源分配和调度的独立单位. 一般情况下,我们所说的进程实体(也叫进程映像)简称进程,进程实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmOxyp3.html" rel="bookmark" class="title">Ext1&period;X的CheckboxSelectionModel默认全选之后不允许编辑的BUG解决方案</a>
					<div>
						Ext1.X的CheckboxSelectionModel默认全选之后不允许编辑的BUG解决方案,ext 的CheckboxSelectionModel在后台默认选中之后,前台就不允许编辑的bug是存 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47myP60.html" rel="bookmark" class="title">poj 3661 Running dp</a>
					<div>
						题意: 有n分钟时间,每分钟牛能跑d[i]路程,在每分钟,牛可以选择跑,这样疲劳度会+1,也可以选择不跑,这样疲劳度会-1(最少到0),问n分钟后疲劳度为0时最多能跑多远,注意牛要疲劳度为0才能继续跑 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ML2maB3.html" rel="bookmark" class="title">windows server 2016 课程讲义（六）</a>
					<div>
						群集创建: 测试群集节点配置:必须通过测试,保留测试报告 创建:定义群集用于管理的DNS名称和IP地址 群集角色:当前群集支持的可以实现高可用的服务,要求所有节点必须安装相同服务 默认环境群集支持服务 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz1R9q4.html" rel="bookmark" class="title">&lpar;转&rpar;日期类型的input元素设置默认值为当天</a>
					<div>
						原文地址 html5的form元素对日期时间有丰富的支持 &lt;input type=&quot;date&quot;&gt; &lt;input type=&quot;time&quot;&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lenAL3.html" rel="bookmark" class="title">poj2406--Power Strings（KMP求最小循环节）</a>
					<div>
						Power Strings Time Limit: 3000MS   Memory Limit: 65536K Total Submissions: 33178   Accepted: 13792 D ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmYzPKM.html" rel="bookmark" class="title">c&plus;&plus;初步实现的一个LRU</a>
					<div>
						#include&lt;iostream&gt;#include&lt;map&gt; using namespace std; typedef struct Node{ int data; stru ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDNkP83.html" rel="bookmark" class="title">Hihocoder 2月29日</a>
					<div>
						import java.util.Scanner; public class Main { static String[] month={ &quot;January&quot;,&quot;Febr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qGKJDM.html" rel="bookmark" class="title">C&num;--静态函数成员</a>
					<div>
											</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmmGN1M.html" rel="bookmark" class="title">黑马程序员&mdash;&mdash;String、StringBuffer和基本数据包装类</a>
					<div>
						类String------------------------------------------------ 一.概述 (一)定义:String是字符串的类类型,用于描述字符串事物. (二)特点:字 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xAr2j3.html" rel="bookmark" class="title">R获取股票数据</a>
					<div>
						R中好几个Pkg都提供了股票数据的在线下载方法,如果非得在其中找出一个最好的,那么quantmod当之无愧!举一个例子,譬如下载沪市大盘数据,代码可以是: library(quantmod)SSE & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWdjXb0.html" rel="bookmark" class="title">WINFORM--第一讲</a>
					<div>
						第一大内容窗体:一.控制标题栏Text - 控制标题栏的文字Icon - 控制标题栏的图标MaximizeBox - 最大化框MinimizeBox -最小化框ControlBox - 所有的最大化. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bL76p4.html" rel="bookmark" class="title">1&period;5 高速找出机器故障</a>
					<div>
						题目:如果一个机器仅仅存储一个标号为ID的记录,如果每份数据保存2个备份,这样就有2个机器存储了同样的数据.当中ID是小于10亿的整数. 问题1.在某个时间.假设得到一个数据文件ID的列表. 是否可以 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
